"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _store = require("./store");
var _sdkParams = require("./sdkParams");
var _events = _interopRequireDefault(require("../events.module"));
var _messageQueues = _interopRequireDefault(require("./store/messageQueues"));
var _httpRequest = _interopRequireDefault(require("./helpers/httpRequest"));
var _errorHandler = _interopRequireDefault(require("./errorHandler"));
var _dompurify = _interopRequireDefault(require("dompurify"));
var _jsdom = require("jsdom");
var _fs = _interopRequireDefault(require("fs"));
var _fileMethods = _interopRequireDefault(require("./chat/fileMethods"));
function App() {
  var app = {};
  app.errorHandler = new _errorHandler["default"](app);
  app.store = new _store.Store(app);
  app.sdkParams = new _sdkParams.SDKParams();
  app.chatEvents = new _events["default"](app);
  app.messageQueues = new _messageQueues["default"](app);
  app.httpRequest = new _httpRequest["default"](app);
  app.domPurify = (0, _dompurify["default"])(new _jsdom.JSDOM('').window);
  app.fs = _fs["default"];
  app.fileMethods = new _fileMethods["default"](app);
  return app;
}
var _default = App;
exports["default"] = _default;